/*
          Program: EvalTi51.c
       Written by: Christopher A. Zielinski,  (CIS: 72723,2701)
             Date: 94.06.24

          Compile: CL EvalTi51.c /c /AL /FPa /Gs /Zl

       Copyright (c) 1994  Christopher A. Zielinski
*/
////////////////////////////////////////////////////////////////////////////////

#include "evalti51.h"
         
volatile static byte _far *indos = 0;
static int Ticks = 0;
static int TickerCount = 0;
static int tHooked = FALSE;
static SYMBOL * symTIME;
union REGS ir, or;

CLIPPER _TIHook() {

  byte uiSuccess = FALSE;

  if (PCOUNT == 1 && ISNUM( 1 )) {
    if ( ( Ticks = _parni( 1 ) * TICKS_PER_SEC ) >= 1 ) {
      TickerCount = Ticks;
      if (! tHooked) {
        if  ( ! indos ) {    // If indos is a NULL pointer
          indos = _getindosAddress();    // Get indos's address (pointer)
        }
        symTIME = _chk_sym( "_TIME_EVAL" );
        if (symTIME) {
          old_int = (void _far *) _dos_getvect( INT_TICKS );    // Get INT_TICKS ISR vector
          _disable(); // Disable ISR's before modifying INT_TICKS vector
          _dos_setvect( INT_TICKS, (void (_cdecl _interrupt _far *)(void)) ISR_Routine );
          _enable();  // Enable ISR's after INT_TICKS vector modification
          tHooked = TRUE;
          uiSuccess = TRUE;
        }
      }
    }
  }
  _retl( uiSuccess );
}


CLIPPER _TIUnHook() {

  byte uiSuccess = FALSE;

  if (tHooked) {
    _disable();
    _dos_setvect( INT_TICKS, (void (_cdecl _interrupt _far *)(void)) old_int );
    _enable();
    old_int = NULL;
    tHooked = FALSE;
    uiSuccess = TRUE;
  }
  _retl( uiSuccess );
}


void _cdecl _interrupt _far ISR_Routine()
{
  // Gate logic based on time passed
  if ( ++TickerCount >= Ticks ) {

    //  InDOS is a flag used by DOS itself.  When DOS enters an Int 21h
    //  function DOS increments the InDOS flag; when DOS leaves, it
    //  decrements the flag.  This flag is required because the operating
    //  system kernal is not fully reentrant!
    //
    //  Some times this flag can be misleading, but better safe than sorry.

    if (! *indos) {
      _disable();
      _putsym( symTIME );       // push function on Clipper stack
      (++_tos)->type = VT_NIL;  // push a NIL value for self
      _xdo(0);                  // call function passing zero parameters
      _ret();                   // _eval->type = VT_NIL
      TickerCount = 0;  
      _enable();
    }
  }
  // Return control to the computer's original timer vector
  _chain_intr( old_int ); 
}


byte _far *_getindosAddress( void )
{
  union REGS in, out;
  struct SREGS sregs;

  in.h.ah = 0x34;
  segread( &sregs );
  intdosx( &in, &out, &sregs );

  // Int 21h Function 34h -- Return address of InDOS Flag
  //
  // Calling Registers:  AH      34h
  //  Return Registers:  ES:BX   Pointer to InDOS Flag

  return(
    (char _far *)
    ( ((unsigned long)(sregs.es)<<16) | (unsigned long)(out.x.bx) ) );
}


